//css_ref System.Data;
//css_ref System.Transactions;
//css_ref System.Xml;
//css_ref Interop.SAPbobsCOM.dll;
//css_ref log4net.dll;
//css_ref Produmex.Foundation.dll;
//css_ref Produmex.Foundation.Data.dll;
//css_ref Produmex.Foundation.Data.Sbo.dll;
//css_ref Produmex.Sbo.Logex.Data.dll;
//css_ref Produmex.Sbo.Logex.Gordon.dll;

using System;
using System.Diagnostics;
using System.Reflection;
using System.Transactions;
using Produmex.Foundation.Data.Sbo;
using Produmex.Foundation.Data.Sbo.Attributes;
using Produmex.Foundation.Data.Sbo.BusinessObjects;
using Produmex.Foundation.Data.Sbo.BusinessObjects.Convertors;
using Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions;
using Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.Tables;
using Produmex.Foundation.Data.Sbo.Providers;
using Produmex.Foundation.Data.Sbo.Utilities;
using Produmex.Foundation.Diagnostics;
using Produmex.Foundation.Reflection;
using Produmex.Foundation.Resources;
using Produmex.Sbo.Logex.Data;
using Produmex.Sbo.Logex.Data.BusinessObjects;
using Produmex.Sbo.Logex.Data.BusinessObjects.Definitions;
using Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.Tables;
using Produmex.Sbo.Logex.Data.Providers;
using Produmex.Sbo.Logex.Gordon.BusinessObjects.Definitions;
using Produmex.Sbo.Logex.Gordon.Generators.CreateSAPDeliveryFromPMXDeliveryController;
using Produmex.Sbo.Logex.Gordon.ViewObjects.Definitions.Views;

namespace AddUpdateScript
{
	class Program
	{
		static string CONNECTION_STRING = "Server=PDMX-POLLAKA;CompanyDB=TESTDB_181;ExtraDb=PMX_TESTDB_181;UseTrusted=False;DbUserName=sa;DbPassword=B1Admin;UserName=manager;Password=manager;Pooling=True;MinPoolSize=2;MaxPoolSize=10;ServerType=MSSQL2014;DBCultureInfo=en-US;LicenseServer=PDMX-POLLAKA:30000";

		/// <summary>
		/// Used for logging
		/// </summary>
		private static readonly ILog s_log = LogProvider.GetLogger(MethodInfo.GetCurrentMethod().DeclaringType);

		static void Main(string[] args)
		{
			try
			{
				Produmex.Foundation.Diagnostics.LogProvider.SetConsoleAppender("WARN");
				Execute();
			}
			catch (Exception ex)
			{
				s_log.Error("", ex);
			}
			if (Debugger.IsAttached)
			{
				Console.WriteLine("Press <Enter>");
				Console.ReadLine();
			}
		}

		private static readonly Assembly s_gordonAssembly = typeof(Produmex.Sbo.Logex.Gordon.SboCommands).Assembly;
		private static string LOCATION_SCRIPTS = "Produmex.Sbo.Logex.Gordon.Scripts.";

		static void Execute()
		{
			using (TransactionScope scope = PmxDbConnection.GetNewTransactionScope())
			{
                using (SboConnection conn = new SboConnection(CONNECTION_STRING))
                {
                    conn.Open();
                    Console.WriteLine("SBO connection is open to database");

					//PmxDbVersionUpdaterProvider updateProv = new PmxDbVersionUpdaterProvider(conn);

					//Console.WriteLine("UDF's created by Vision33");
					//SboUserFieldMDProvider udfProv = new SboUserFieldMDProvider(conn);
					//udfProv.AddUpdateUserfield("DLN7", new SboColumnDefinitionAttribute("U_V33_TRACK", "Package Tracking num.", SboFieldType.Alpha, 30, SboFieldSubType.None));
					//udfProv.AddUpdateUserfield("DLN7", new SboColumnDefinitionAttribute("U_V33_CARRIER", "Carrier name", SboFieldType.Alpha, 50, SboFieldSubType.None));
					//udfProv.AddUpdateUserfield("DLN7", new SboColumnDefinitionAttribute("U_V33_CLASS", "Class", SboFieldType.Alpha, 50, SboFieldSubType.None));
					//udfProv.AddUpdateUserfield("DLN7", new SboColumnDefinitionAttribute("U_V33_FREIGHT", "Freight value of the package", SboFieldType.Float, 10, SboFieldSubType.Measurement));
					//udfProv.AddUpdateUserfield("DLN7", new SboColumnDefinitionAttribute("U_V33_WEIGHT", "Box weight", SboFieldType.Float, 10, SboFieldSubType.Measurement));
					//udfProv.AddUpdateUserfield("DLN7", new SboColumnDefinitionAttribute("U_V33_DIM", "Dimensions", SboFieldType.Alpha, 100, SboFieldSubType.None));
					//udfProv.AddUpdateUserfield("DLN7", new SboColumnDefinitionAttribute("U_V33_SHIPACCT", "Shipping Account", SboFieldType.Alpha, 50, SboFieldSubType.None));
				}

				//Complete transaction
				scope.Complete();
			}

			//PMX connection
			using (TransactionScope scope = PmxDbConnection.GetNewTransactionScope())
			{
				using (PmxDbConnectionHana dbConn = new PmxDbConnectionHana(CONNECTION_STRING))
				{
					dbConn.Open();
					Console.WriteLine("PMX connection is open to database");

					Console.WriteLine("Tables");

					Console.WriteLine("Views");
					dbConn.DbTool.CreateUpdateView(
						PmxGordonOpenPmxSalesShippingView.NAME,
						PreprocessSqlScript(ResourceHelper.ReadResourceContentAsString(s_gordonAssembly, LOCATION_SCRIPTS + "Views." + PmxGordonOpenPmxSalesShippingView.NAME + ".sql"), dbConn));

					Console.WriteLine("Extensions");
					AddUpdateExtension(
						GordonCreateSAPDeliveryFromPMXDeliveryController.IDs.ExtCode,
						GordonCreateSAPDeliveryFromPMXDeliveryController.IDs.Description,
						typeof(GordonCreateSAPDeliveryFromPMXDeliveryController),
						Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.PmxExtensionTypeCodes.ICREATEDELIVERYCONTROLLER,
						dbConn);

					AddUpdateExtensionParameter(
						GordonCreateSAPDeliveryFromPMXDeliveryController.IDs.ExtParamViewName,
						"View Name",
						GordonCreateSAPDeliveryFromPMXDeliveryController.IDs.ExtCode,
						Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.PmxExtensionCodes.SYSTEM_STRING_CONVERTOR,
						PmxGordonOpenPmxSalesShippingView.NAME,
						PmxExtensionParameterCodesGordon.CREATE_SAP_DELIVERY_FROM_PMX_DELIVERY_VIEW_NAME,
						null,
						dbConn);

					//Complete transaction
					scope.Complete();
				}
			}

			Console.WriteLine("Done ...");
		}

		/// <summary>
		/// Add/Update <see cref="PmxExtension"/>
		/// </summary>
		/// <param name="code">The code of the extension.</param>
		/// <param name="name">The name of the extension.</param>
		/// <param name="type">The type of the extension.</param>
		/// <param name="extensionTypeCode">The extension type code.</param>
		/// <param name="conn">The SBO connection</param>
		private static void AddUpdateExtension(string code, string name, Type type, string extensionTypeCode, PmxDbConnectionHana conn)
		{
			PmxExtensionProvider prov = new PmxExtensionProvider(conn);
			PmxExtension extension = null;
			try
			{
				bool newBO = false;
				extension = prov.GetBO(code);
				if (extension == null)
				{
					newBO = true;
					extension = prov.GetNewBO();
					extension.Code = code;
				}
				extension.Name = name;
				extension.ExtensionTypeCode = extensionTypeCode;
				extension.Type = ReflectionHelper.GetTypeAndAssemblyName(type);
				if (newBO)
				{
					prov.AddBO(extension);
				}
				else
				{
					prov.UpdateBO(extension, false, false);
				}
			}
			finally
			{
				if (extension != null) extension.Dispose();
			}
		}




		/// <summary>
		/// Add/Update script workflow
		/// </summary>
		/// <param name="executionType">Type of the execution.</param>
		/// <param name="name">The name of the flow.</param>
		/// <param name="sourceFilePath">Name of the file.</param>
		/// <param name="sqlConn">The SQL conn.</param>
		private static void AddUpdateWorkflowScript(string executionType, string name, string sourceFilePath, PmxDbConnectionHana sqlConn)
		{
			PmxWorkflowProvider wfProvider = new PmxWorkflowProvider(sqlConn);
			PmxWorkflow workflow = wfProvider.GetWorkflowByName(name);
			PmxWorkflowScriptProvider wfscProvider = new PmxWorkflowScriptProvider(sqlConn);
			PmxWorkflowScript bo = null;
			if (workflow == null)
			{
				//add the workflow
				bo = wfscProvider.GetNewBO();
				bo.Name = name;
				wfscProvider.AddBO(bo);
			}
			else
			{
				if (workflow.ObjType == Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.PmxObjectTypes.PmxWorkflowScript)
				{
					bo = wfscProvider.GetBO(workflow.InternalKey);

				}
			}

			if (bo != null)
			{
				bo.ExecutionType = executionType;

				wfscProvider.UpdateSourceFromFileAndCompile(bo, sourceFilePath, sqlConn);
			}



		}

		/// <summary>
		/// Runs the table SQL script.
		/// </summary>
		/// <param name="tableScript">The table script.</param>
		/// <param name="conn">The conn.</param>
		private static void RunTableSqlScript(string tableScript, PmxDbConnection conn)
		{
			//string content = ResourceHelper.ReadResourceContentAsString(Assembly.GetAssembly(typeof(Produmex.Sbo.Logex.Gordon.SboCommands)), "Produmex.Sbo.Logex.Gordon.Scripts.Tables." + tableScript);
			//SboRecordsetHelper.RunSqlScript(s_log, content, conn);
		}

		/// <summary>
		/// Adds the update user fields not in transaction.
		/// </summary>
		/// <param name="conn">The conn.</param>
		/// <param name="types">The types.</param>
		private static void AddUpdateUserFieldsNotInTransaction(SboConnection conn, params Type[] types)
		{
			SboUserFieldMDProvider userFieldMDProv = new SboUserFieldMDProvider(conn);
			//System.Data.Common.DbTransaction transaction = null;
			try
			{
				//transaction = this.Connection.BeginTransaction();
				userFieldMDProv.AddUpdateUserFields(types);

				//Commit transaction
				//transaction.Commit();
			}
			catch (Exception)
			{
				//if (transaction != null) transaction.Rollback();
				throw;
			}
		}

		/// <summary>
		/// Runs the stored procedure SQL script.
		/// </summary>
		/// <param name="spScript">The sp script.</param>
		/// <param name="conn">The conn.</param>
		private static void RunStoredProcedureSqlScript(string spScript, PmxDbConnection conn)
		{
			//string content = ResourceHelper.ReadResourceContentAsString(Assembly.GetAssembly(typeof(Produmex.Sbo.Logex.Gordon.SboCommands)), "Produmex.Sbo.Logex.Gordon.Scripts.StoredProcedures." + spScript);
			//SboRecordsetHelper.RunSqlScript(s_log, content, conn);
		}

		/// <summary>
		/// Add/Update <see cref="PmxExtensionParameter" />
		/// </summary>
		/// <param name="code">The code of the extension parameter.</param>
		/// <param name="name">The name of the extension parameter.</param>
		/// <param name="extensionCode">The extension code.</param>
		/// <param name="convertorCode">The convertor code.</param>
		/// <param name="defaultValue">The default value.</param>
		/// <param name="grouping">The grouping parameter.</param>
		/// <param name="conn">The connection parameter</param>
		private static void AddUpdateExtensionParameter(string code, string name, string extensionCode, string convertorCode, string defaultValue, string grouping, PmxDbConnection conn)
		{
			AddUpdateExtensionParameter(code, name, extensionCode, convertorCode, defaultValue, code, grouping, conn);
		}

		/// <summary>
		/// Add/Update <see cref="PmxExtensionParameter" />
		/// </summary>
		/// <param name="code">The code of the extension parameter.</param>
		/// <param name="name">The name of the extension parameter.</param>
		/// <param name="extensionCode">The extension code.</param>
		/// <param name="convertorCode">The convertor code.</param>
		/// <param name="defaultValue">The default value.</param>
		/// <param name="generalParameterCode">The general parameter code.</param>
		/// <param name="grouping">The grouping parameter.</param>
		/// <param name="conn">The connection parameter</param>
		private static void AddUpdateExtensionParameter(string code, string name, string extensionCode, string convertorCode, string defaultValue, string generalParameterCode, string grouping, PmxDbConnection conn)
		{
			AddUpdateExtensionParameter(code, name, extensionCode, convertorCode, defaultValue, generalParameterCode, 0, grouping, conn);
		}

		/// <summary>
		/// Add/Update <see cref="PmxExtensionParameter" />
		/// </summary>
		/// <param name="code">The code of the extension parameter.</param>
		/// <param name="name">The name of the extension parameter.</param>
		/// <param name="extensionCode">The extension code.</param>
		/// <param name="convertorCode">The convertor code.</param>
		/// <param name="defaultValue">The default value.</param>
		/// <param name="generalParameterCode">The general parameter code.</param>
		/// <param name="sequence">The sequence parameter.</param>
		/// <param name="grouping">The grouping parameter.</param>
		/// <param name="conn">The connection parameter</param>
		private static void AddUpdateExtensionParameter(string code, string name, string extensionCode, string convertorCode, string defaultValue, string generalParameterCode, int sequence, string grouping, PmxDbConnection conn)
		{
			PmxExtensionParameterProvider prov = new PmxExtensionParameterProvider(conn);
			PmxExtensionParameter extParam = null;

			try
			{
				bool newBO = false;
				extParam = prov.GetBO(code);

				if (extParam == null)
				{
					newBO = true;
					extParam = prov.GetNewBO();
					extParam.Code = code;
				}

				extParam.Name = name;
				extParam.ExtensionCode = extensionCode;
				extParam.ConvertorCode = convertorCode;
				extParam.GeneralParameterCode = generalParameterCode;
				extParam.DefaultValue = defaultValue;
				extParam.Sequence = sequence;
				extParam.Grouping = grouping;

				if (newBO)
				{
					prov.AddBO(extParam);
				}
				else
				{
					prov.UpdateBO(extParam, false, false);
				}
			}
			finally
			{
				if (extParam != null)
					extParam.Dispose();
			}
		}

		/// <summary>
		/// Preprocesses the SQL script.
		/// </summary>
		/// <param name="query">The query.</param>
		/// <param name="conn">The connection.</param>
		/// <returns></returns>
		private static string PreprocessSqlScript(string query, PmxDbConnection conn)
		{
			string serverType;
			switch (conn.ConnectionStringObject.ServerType)
			{
				case SboServerType.HANA:
					serverType = "HANA";
					query = query.Replace("{DB-SCHEMA}", "\"" + conn.ConnectionStringObject.CompanyDBSchema.SchemaName + "\"")
								 .Replace("{EXTRA-DB-SCHEMA}", "\"" + conn.ConnectionStringObject.ExtraDBSchema.SchemaName + "\"");
					break;
				default:
					serverType = "MSSQL";
					break;
			}

			int mssqlBlockBegin = query.IndexOf("--<?DB:");
			while (mssqlBlockBegin >= 0)
			{
				int mssqlBlockEnd = query.IndexOf("--?>", mssqlBlockBegin);
				if (mssqlBlockEnd < 0)
				{
					break;
				}

				if (query.Substring(mssqlBlockBegin + "--<?DB:".Length, serverType.Length) == serverType)
				{
					query = query.Substring(0, mssqlBlockBegin)
						  + query.Substring(mssqlBlockBegin + "--<?DB:".Length + serverType.Length, mssqlBlockEnd - mssqlBlockBegin - "--<?DB:".Length - serverType.Length)
						  + query.Substring(mssqlBlockEnd + "--?>".Length);
					mssqlBlockEnd -= "--<?DB:".Length + serverType.Length + "--?>".Length;
				}
				else
				{
					query = query.Substring(0, mssqlBlockBegin) + query.Substring(mssqlBlockEnd + "--?>".Length);
					mssqlBlockEnd = mssqlBlockBegin;
				}
				mssqlBlockBegin = query.IndexOf("--<?DB:", mssqlBlockEnd);
			}

			if (conn.ConnectionStringObject.ServerType == SboServerType.HANA)
			{
				int tokenPos = query.IndexOf("ISNULL(", StringComparison.OrdinalIgnoreCase);
				while (tokenPos >= 0)
				{
					int endPos = tokenPos + "ISNULL(".Length;
					query = query.Substring(0, tokenPos) + "IFNULL(" + query.Substring(endPos);
					tokenPos = query.IndexOf("ISNULL(", endPos, StringComparison.OrdinalIgnoreCase);
				}

				tokenPos = query.IndexOf("@");
				while (tokenPos >= 0)
				{
					if (query[tokenPos - 1] != '"' && Char.IsLetter(query[tokenPos + 1]))
					{
						query = query.Substring(0, tokenPos) + "p_" + query.Substring(tokenPos + 1);
					}
					tokenPos = query.IndexOf("@", tokenPos + 2);
				}
			}

			return query;
		}
	}
}
